## org.apache.commons.collections.bag
Class PredicatedSortedBag

    java.lang.Object
      org.apache.commons.collections.collection.AbstractCollectionDecorator
          org.apache.commons.collections.collection.AbstractSerializableCollectionDecorator
              org.apache.commons.collections.collection.PredicatedCollection
                  org.apache.commons.collections.bag.PredicatedBag
                      org.apache.commons.collections.bag.PredicatedSortedBag

All Implemented Interfaces:
  java.io.Serializable, java.lang.Iterable, java.util.Collection, Bag, SortedBag

    public class PredicatedSortedBag

extends PredicatedBag
implements SortedBag

Decorates another `SortedBag` to validate that additions match a specified predicate.

This bag exists to provide validation for the decorated bag. It is normally created to decorate an empty bag. If an object cannot be added to the bag, an IllegalArgumentException is thrown.

One usage would be to ensure that no null entries are added to the bag.

    SortedBag bag = PredicatedSortedBag.decorate(new TreeBag(), NotNullPredicate.INSTANCE);

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne, Paul Jack
See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.commons.collections.collection.PredicatedCollection
`predicate`

Fields inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`collection`

Constructor Summary
`protected` `PredicatedSortedBag(SortedBag bag, Predicate predicate)` Constructor that wraps (not copies).

Method Summary
`java.util.Comparator` `comparator()` Returns the comparator associated with this sorted set, or null if it uses its elements' natural ordering.
`static SortedBag` `decorate(SortedBag bag, Predicate predicate)` Factory method to create a predicated (validating) bag.
`java.lang.Object` `first()` Returns the first (lowest) member.
`protected SortedBag` `getSortedBag()` Gets the decorated sorted bag.
`java.lang.Object` `last()` Returns the last (highest) member.

Methods inherited from class org.apache.commons.collections.bag.PredicatedBag
`add, decorate, getBag, getCount, remove, uniqueSet`

Methods inherited from class org.apache.commons.collections.collection.PredicatedCollection
`add, addAll, decorate, validate`

Methods inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`clear, contains, containsAll, equals, getCollection, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.Bag
`add, add, containsAll, getCount, iterator, remove, remove, removeAll, retainAll, size, uniqueSet`

Methods inherited from interface java.util.Collection
`addAll, clear, contains, equals, hashCode, isEmpty, toArray, toArray`

Constructor Detail

### PredicatedSortedBag

    protected PredicatedSortedBag(SortedBag bag,
                                  Predicate predicate)

  Constructor that wraps (not copies).

  If there are any elements already in the bag being decorated, they are validated.

  Parameters:
    `bag` - the bag to decorate, must not be null
    `predicate` - the predicate to use for validation, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if bag or predicate is null
    `java.lang.IllegalArgumentException` - if the bag contains invalid elements

Method Detail

### decorate

    public static SortedBag decorate(SortedBag bag,
                                     Predicate predicate)

  Factory method to create a predicated (validating) bag.

  If there are any elements already in the bag being decorated, they are validated.

  Parameters:
    `bag` - the bag to decorate, must not be null
    `predicate` - the predicate to use for validation, must not be null
  Returns:
    a new predicated SortedBag
  Throws:
    `java.lang.IllegalArgumentException` - if bag or predicate is null
    `java.lang.IllegalArgumentException` - if the bag contains invalid elements

### getSortedBag

    protected SortedBag getSortedBag()

  Gets the decorated sorted bag.

  Returns:
    the decorated bag

### first

    public java.lang.Object first()

  Description copied from interface: `SortedBag`
  Returns the first (lowest) member.

  Specified by:
    `first` in interface `SortedBag`
  Returns:
    the first element in the sorted bag

### last

    public java.lang.Object last()

  Description copied from interface: `SortedBag`
  Returns the last (highest) member.

  Specified by:
    `last` in interface `SortedBag`
  Returns:
    the last element in the sorted bag

### comparator

    public java.util.Comparator comparator()

  Description copied from interface: `SortedBag`
  Returns the comparator associated with this sorted set, or null if it uses its elements' natural ordering.

  Specified by:
    `comparator` in interface `SortedBag`
  Returns:
    the comparator in use, or null if natural ordering

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.